VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "Queue"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False


Private q() As String
Private size As Integer
Private head As Integer
Private tail As Integer

Public Sub Initialize(n As Integer)

    ReDim q(0 To n - 1)
    
    size = n
    head = 0
    tail = 0

End Sub


Public Sub Add(s As String)

    If Not IsFull Then
    
        q(tail) = s
        tail = (tail + 1) Mod size
    
    End If

End Sub


Public Function Remove() As String

    If Not IsEmpty Then
   
        Remove = q(head)
        head = (head + 1) Mod size
   
    End If

End Function


Public Sub Clear()

    head = tail

End Sub


Public Function Count() As Integer

    Count = ((tail + size) - head) Mod size

End Function


Public Function IsEmpty() As Boolean

    If head = tail Then IsEmpty = True Else IsEmpty = False

End Function


Public Function IsFull() As Boolean

    If head = ((tail + 1) Mod size) Then IsFull = True Else IsFull = False

End Function
